package aufgabe4;

/**
 * Generic test class defining a simple encryption by association
 *                _ _   _               _
 * __      ___ __(_) |_| |_ ___ _ __   | |__  _   _
 * \ \ /\ / / '__| | __| __/ _ \ '_ \  | '_ \| | | |
 *  \ V  V /| |  | | |_| ||  __/ | | | | |_) | |_| |
 *   \_/\_/ |_|  |_|\__|\__\___|_| |_| |_.__/ \__, |
 *                                            |___/
 *  ____                  __     __               _
 * / ___|_   _____ _ __   \ \   / /__   __ _  ___| |
 * \___ \ \ / / _ \ '_ \   \ \ / / _ \ / _` |/ _ \ |
 *  ___) \ V /  __/ | | |   \ V / (_) | (_| |  __/ |
 * |____/ \_/ \___|_| |_|    \_/ \___/ \__, |\___|_|
 *                                     |___/
 * Licensed under the GPLv2 License, Version 2.0 (the "License");
 * Copyright (c) Sven Vogel
 */
public class GeheimtextalphabetVerschiebung implements Chiffrierung {

    private final char[] map;

    public GeheimtextalphabetVerschiebung(char[] map) {
        if (map.length != 26)
            throw new IllegalArgumentException("Character map must be 26 characters long");

        this.map = map;
    }

    @Override
    public char chiffrieren(char zeichen) {
        if (Character.isLowerCase(zeichen)) {
            return this.map[zeichen - 'a'];
        }
        return zeichen;
    }

    @Override
    public char dechiffrieren(char zeichen) {
        if (Character.isLowerCase(zeichen)) {
            for (int i = 0; i < map.length; i++) {
                if (map[i] == zeichen) {
                    return (char) ('a' + i);
                }
            }
        }
        return zeichen;
    }
}
