package aufgabe4;

public final class Verschluesselung {

    /**
     * Encrypt all characters in a string with a specified encryption
     * @param text text to encrypt
     * @param chiffrierung algorithm to use
     * @return the encrypted text
     */
    public static String verschluesseln(String text, Chiffrierung chiffrierung) {
        var builder = new StringBuilder();

        for (int i = 0; i < text.length(); i++) {
            builder.append(chiffrierung.chiffrieren(text.charAt(i)));
        }

        return builder.toString();
    }

    /**
     * Decrypt all characters in a string with a specified encryption
     * @param text text to decrypt
     * @param chiffrierung algorithm to use
     * @return the decrypted text
     */
    public static String entschluesseln(String text, Chiffrierung chiffrierung) {
        var builder = new StringBuilder();

        for (int i = 0; i < text.length(); i++) {
            builder.append(chiffrierung.dechiffrieren(text.charAt(i)));
        }

        return builder.toString();
    }
}
