package aufgabe1;

public record Book(String title, String author, String verlag, double value, boolean available) {

    public static Book parseFromCommaSeparatedString(String line) {
        var values = line.split(",");
        try {
            return new Book(values[0], values[1], values[2], Double.parseDouble(values[3]), Boolean.parseBoolean(values[4]));
        } catch (ArrayIndexOutOfBoundsException ignored) {
            throw new IllegalArgumentException("not enough entries for book");
        } catch (NumberFormatException ignored) {
            throw new IllegalArgumentException("value of book not a number");
        }
    }
}