package aufgabe2;

import javax.swing.*;
import java.awt.event.*;

public class Calculator extends JDialog {
    private JPanel contentPane;
    private JButton buttonOK;
    private JButton buttonCancel;
    private JTextField operandOneTextField;
    private JTextField operandTwoTextField;
    private JButton addButton;
    private JButton subButton;
    private JButton MulButton;
    private JButton divButton;
    private JLabel Result;
    private JTextField resultTextField;

    public Calculator() {
        setContentPane(contentPane);
        setModal(true);
        getRootPane().setDefaultButton(buttonOK);

        buttonOK.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onOK();
            }
        });

        buttonCancel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        });

        // call onCancel() when cross is clicked
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                onCancel();
            }
        });

        // call onCancel() on ESCAPE
        contentPane.registerKeyboardAction(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                onCancel();
            }
        }, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);

        addButton.addActionListener(e -> calculate(Double::sum));
        subButton.addActionListener(e -> calculate((a,b) -> a - b));
        MulButton.addActionListener(e -> calculate((a,b) -> a * b));
        divButton.addActionListener(e -> calculate((a,b) -> a / b));

        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        pack();
        setLocationByPlatform(true);
        setVisible(true);
    }

    private void calculate(Calculate operation) {
        try {
            var op0 = Double.parseDouble(operandOneTextField.getText());
            var op1 = Double.parseDouble(operandTwoTextField.getText());

            var res = operation.calculate(op0, op1);

            resultTextField.setText(res.toString());
        } catch (NumberFormatException e) {
            JOptionPane.showInternalMessageDialog(null, "Operand numbers must be valid", "Calculation", JOptionPane.ERROR_MESSAGE);
        }
    }

    private void onOK() {
        // add your code here
        dispose();
    }

    private void onCancel() {
        // add your code here if necessary
        dispose();
    }
}
